#include <exec/types.h>
#include <hardware/custom.h>
#include <exec/memory.h>
#include <graphics/gfxbase.h>
#include <graphics/rastport.h>
#include <intuition/intuitionbase.h>
#include <libraries/dos.h>

UBYTE *taste=0xbfec01;
WORD *BDMA=0xdff100;

extern UWORD *Baukaplane;
extern UWORD *Shadowsourceplane;
extern struct BitMap ShadowSourceMap;
extern struct BitMap BaukaMap;
  
extern void *AllocRaster(), *AllocMem(), *OpenLibrary();

struct GfxBase *GfxBase;

#asm
   public _colset7
_colset7:
   move.w #$000,$dff180
   move.w #$ddd,$dff182 
   move.w #$005,$dff184
   move.w #$117,$dff186
   move.w #$229,$dff188
   move.w #$44b,$dff18a
   move.w #$77d,$dff18c
   move.w #$aaf,$dff18e
   move.w #$500,$dff190
   move.w #$711,$dff192
   move.w #$922,$dff194
   move.w #$b44,$dff196
   move.w #$d77,$dff198
   move.w #$faa,$dff19a
   move.w #$550,$dff19c
   move.w #$771,$dff19e
   move.w #$992,$dff1a0   
   move.w #$bb4,$dff1a2
   move.w #$dd7,$dff1a4
   move.w #$ffa,$dff1a6
   move.w #$505,$dff1a8
   move.w #$717,$dff1aa
   move.w #$929,$dff1ac
   move.w #$b4b,$dff1ae
   move.w #$d7d,$dff1b0
   move.w #$faf,$dff1b2
   move.w #$055,$dff1b4
   move.w #$177,$dff1b6
   move.w #$299,$dff1b8
   move.w #$4bb,$dff1ba
   move.w #$7dd,$dff1bc
   move.w #$aff,$dff1be
   rts
#endasm

UWORD Clearcopl[]= {
 0x0100, 0x0000,
  0xffff,0xfffe };  

UWORD Topcopl[]= {
 0x008E,0x2981, /*  Display Window VSTART,HSTART            */
 0x0090,0x29C1, /*  Display Window VSTOP,HSTOP              */
 0x0092,0x0038, /*  Display Data fetch Start LOW RES        */
 0x0094,0x00D0, /*  Display Data fetch Stop                 */
 0x0102,0x0000, /*  No PlayField scroll                     */
 0x0104,0x0024, /*  All Sprites in front of both PlayFields */
 0x0108,0x00a0, /*  BitPlane Modulo odd Planes              */
 0x010A,0x00a0, /*  BitPlane Modulo even Planes             */
 0x00E0,0x0000, /*  Plane 1 Pointer (high 3 bits)           */
 0x00E2,0x0000, /*  Plane 1 Pointer (low 15 bits)           */
 0x00E4,0x0000, /*  Plane 2                                 */
 0x00E6,0x0000,
 0x00E8,0x0000, /*  Plane 3                                 */
 0x00EA,0x0000,
 0x00EC,0x0000, /*  Plane 4                                 */
 0x00ee,0x0000,
 0x00f0,0x0000, /*  Plane 5                                 */
 0x00f2,0x0000,
 0x0100,0x5200, /* 5 BitPlanes, LOW RES, Color_ON   genau 70    */ 
 0x0120,0x0000, /* Sprite 0  1. Pointer (high 3 bits) */ 
 0x0122,0x0000, /* Sprite 0  2. Pointer (low 15 bits) */
 0x0124,0x0000, /* Sprite 1  1. Pointer (high 3 bits) */ 
 0x0126,0x0000, /* Sprite 1  2. Pointer (low 15 bits) */
 0x0128,0x0000, /* Sprite 2  1. Pointer (high 3 bits) */ 
 0x012a,0x0000, /* Sprite 2  2. Pointer (low 15 bits) */
 0x012c,0x0000, /* Sprite 3  1. Pointer (high 3 bits) */ 
 0x012e,0x0000, /* Sprite 3  2. Pointer (low 15 bits) */
 0x0130,0x0000, /* Sprite 4  1. Pointer (high 3 bits) */ 
 0x0132,0x0000, /* Sprite 4  2. Pointer (low 15 bits) */
 0x0134,0x0000, /* Sprite 5  1. Pointer (high 3 bits) */ 
 0x0136,0x0000, /* Sprite 5  2. Pointer (low 15 bits) */
 0x0138,0x0000, /* Sprite 6  1. Pointer (high 3 bits) */ 
 0x013a,0x0000, /* Sprite 6  2. Pointer (low 15 bits) */
 0x013c,0x0000, /* Sprite 7  1. Pointer (high 3 bits) */ 
 0x013e,0x0000, /* Sprite 7  2. Pointer (low 15 bits) */

 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   
 0x0000, 0x0000, 0x0000, 0x0000,   

 0xff01, 0xfffe,
 0x0100, 0x0000,
 0xffff,0xfffe };

#asm
    public  _TopCop
_TopCop:
   move.l      #_Topcopl,$dff080
   clr.w      $dff088
   rts
    public  _ClCop
_ClCop:
   move.l      #_Clearcopl,$dff080
   clr.w      $dff088
   rts
#endasm

UBYTE *which;
UBYTE *ToWhat;

struct Places {
   char Name[12];
   ULONG Average;
   UWORD Level; 
   UWORD Seconds; };

struct Places Place[10];
   
int j,This,Placed=0;
long File;
UWORD a1,a2;

struct FuchsTracker {
        UBYTE name[10];
        ULONG AllInstrLength;
        UWORD Laenge_Instr[16];
        UWORD Volume[16];
        UWORD Loop[16];
        UWORD PatternAnz;
        UWORD Positions[40]; };
        
struct FuchsTracker *Track;

extern int Fast=6;

extern UWORD *Noten;
extern UWORD *Instruments;

extern UWORD *DMACon;

extern ULONG *Adresse1;
extern UWORD *Laenge1;
extern UWORD *Period1;
extern UWORD *Volume1;

extern ULONG *Adresse2;
extern UWORD *Laenge2;
extern UWORD *Period2;
extern UWORD *Volume2;

extern ULONG *Adresse3;
extern UWORD *Laenge3;
extern UWORD *Period3;
extern UWORD *Volume3;

extern ULONG *Adresse4;
extern UWORD *Laenge4;
extern UWORD *Period4;
extern UWORD *Volume4;

extern long Dummy;

extern UWORD Note1,Note2,Note3,Note4;
extern UWORD Instrument1,Instrument2,Instrument3,Instrument4;

extern int Laenge[17];
extern int Volume[17];
extern short Loop[17];

extern short Pattern[40];

extern UWORD *Start[15];

extern int Notepointer=0,Endpointer;
extern short Position=0; 

extern short Loop1,Loop2,Loop3,Loop4;

extern short counter2=0;

extern UWORD PatternAnz;
/**********************************************************************/

LowScore()
{
  LONG i,Length;
  int count,neu=1,counter;
  register int quas;
 BYTE RR=0,GG=0,BB=0;

  ClCop();

  GfxBase = (struct GfxBase*)OpenLibrary("graphics.library",0L);

  which=AllocMem(2200L,MEMF_CHIP|MEMF_CLEAR);
  ToWhat=AllocMem(2200L,MEMF_CHIP|MEMF_CLEAR);

/*********************  Die Musi loadn loassn !! ************************/
Notepointer=0;
Position=0; 
counter2=0;

Track=AllocMem(sizeof(struct FuchsTracker),MEMF_CHIP|MEMF_CLEAR);

File=Open("df0:LowTheme",MODE_OLDFILE);
Read(File,Track,sizeof(struct FuchsTracker));
Read(File,&Dummy,4);
Read(File,&Length,4);

Instruments=AllocMem(Track->AllInstrLength,MEMF_CLEAR|MEMF_CHIP);
Noten=AllocMem(Length,MEMF_CLEAR|MEMF_CHIP);

Read(File,(UWORD *)Noten,Length);
Read(File,&Dummy,4);
Read(File,(UWORD *)Instruments,Track->AllInstrLength);
Close(File);

for(i=1; i<=16; i++)
        {        
        Start[i]=Instruments;
        *(Start[i])=0;
        *(Start[i]+1)=0;
        Instruments+=(Track->Laenge_Instr[i-1]/2);
        Laenge[i]=(Track->Laenge_Instr[i-1]/2);
        Volume[i]=Track->Volume[i-1];
        Loop[i]=Track->Loop[i-1];
        }

PatternAnz=Track->PatternAnz;

for(i=0; i<PatternAnz; i++) 
        {
        Pattern[i]=Track->Positions[i];
        }

   Notepointer=0;
   Endpointer=512;

	File=Open("df0:LowScore", MODE_OLDFILE);

for(j=0; j<10; j++)
 	{
	Read(File,&Place[j],(long)sizeof(struct Places));
	}

	Close(File); 

        BltClear(BaukaMap.Planes[0], RASSIZE(320L,1300L), 1L);

ReadIn(Baukaplane,"df0:LowScore.cru"); 
ReadIn(Shadowsourceplane,"df0:LowFont.cru"); 
	
#asm
   move.l _Baukaplane,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Topcopl[17]=a2;
Topcopl[19]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #40,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Topcopl[21]=a2;
Topcopl[23]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #80,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Topcopl[25]=a2;
Topcopl[27]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #120,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Topcopl[29]=a2;
Topcopl[31]=a1;
#asm
   move.l _Baukaplane,d3
   add.l #160,d3
   move.w d3,_a1
   swap d3
   move.w d3,_a2
#endasm
Topcopl[33]=a2;
Topcopl[35]=a1;

 quas=70;
 for(i=0; i<141; i++)
 {
 Topcopl[quas]=(0x2a+i)<<8 | 0x01;
 Topcopl[quas+1]=0xfffe;
 Topcopl[quas+2]=0x0182;
 Topcopl[quas+3]=0x0000;
 quas+=4;
 }


File=Open("df0:Colors1",MODE_OLDFILE);
Read(File,(UBYTE *)which,2000L);
Close(File);

File=Open("df0:Colors2",MODE_OLDFILE);
Read(File,(UBYTE *)ToWhat,2000L);
Close(File);

TopCop();
colset7();

counter=-1;

PrintScoreTable();

j=0;

while(1)
{
 for(quas=70; quas<626; quas+=4)
  {
  Topcopl[quas+3]=Topcopl[quas+7];
  }


if(neu==1)
  {
  counter++;
  if(counter>=2000) counter=0;
  neu=0;
  if(*(which+counter)==0 && RR> *(ToWhat+counter)) count=-1;
  if(*(which+counter)==0 && RR< *(ToWhat+counter)) count=1;
  if(*(which+counter)==0 && RR== *(ToWhat+counter)) neu=1;
  if(*(which+counter)==1 && GG> *(ToWhat+counter)) count=-1;
  if(*(which+counter)==1 && GG< *(ToWhat+counter)) count=1;
  if(*(which+counter)==1 && GG== *(ToWhat+counter)) neu=1;
  if(*(which+counter)==2 && BB> *(ToWhat+counter)) count=-1;
  if(*(which+counter)==2 && BB< *(ToWhat+counter)) count=1;
  if(*(which+counter)==2 && BB== *(ToWhat+counter)) neu=1;
  }

  if(*(which+counter)==0 && RR!= *(ToWhat+counter)) RR+=count;
  if(*(which+counter)==0 && RR== *(ToWhat+counter)) neu=1;
  if(*(which+counter)==1 && GG!= *(ToWhat+counter)) GG+=count;
  if(*(which+counter)==1 && GG== *(ToWhat+counter)) neu=1;
  if(*(which+counter)==2 && BB!= *(ToWhat+counter)) BB+=count;
  if(*(which+counter)==2 && BB== *(ToWhat+counter)) neu=1;
	
Topcopl[629]=(RR<<8 | GG<<4 | BB); 
Topcopl[633]=(RR<<8 | GG<<4 | BB); 
   	
if(*taste==0x75) break;

/*********************  Die Musi spuiln loassn !! ************************/
   if(counter2==0)
        {
        Note1=*(Noten+Notepointer);
        Instrument1=(*(Noten+Notepointer+1)>>12);
        Note2=*(Noten+Notepointer+2);
        Instrument2=(*(Noten+Notepointer+3)>>12);
        Note3=*(Noten+Notepointer+4);
        Instrument3=(*(Noten+Notepointer+5)>>12);
        Note4=*(Noten+Notepointer+6);
        Instrument4=(*(Noten+Notepointer+7)>>12);
        }
   if(counter2==1)
        {
        PlayMusik();
        }
   if(counter2==2)
        {
        if(Instrument1!=0)
                {
                Loop1=0;
                if(Loop[Instrument1]) Loop1=1;
                }
        if(Instrument2!=0)
                {
                Loop2=0;
                if(Loop[Instrument2]) Loop2=1;
                }
        if(Instrument3!=0)
                {
                Loop3=0;
                if(Loop[Instrument3]) Loop3=1;
                }
        if(Instrument4!=0)
                {
                Loop4=0;
                if(Loop[Instrument4]) Loop4=1;
                }
   if((*(Noten+Notepointer+1)&0x0c00)) *Volume1=(*(Noten+Notepointer+1)&0xff);
   if((*(Noten+Notepointer+3)&0x0c00)) *Volume2=(*(Noten+Notepointer+3)&0xff);
   if((*(Noten+Notepointer+5)&0x0c00)) *Volume3=(*(Noten+Notepointer+5)&0xff);
   if((*(Noten+Notepointer+7)&0x0c00)) *Volume4=(*(Noten+Notepointer+7)&0xff);
   if((*(Noten+Notepointer+1)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
   if((*(Noten+Notepointer+3)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
   if((*(Noten+Notepointer+5)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
   if((*(Noten+Notepointer+7)&0x0f00)==0x0d00) Notepointer=Endpointer+1;
        }
   if(counter2==3)
        {
   if((*(Noten+Notepointer+1)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+1)&0xf); 
   if((*(Noten+Notepointer+3)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+3)&0xf); 
   if((*(Noten+Notepointer+5)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+5)&0xf); 
   if((*(Noten+Notepointer+7)&0x0f00)==0x0f00) Fast=(*(Noten+Notepointer+7)&0xf); 
        Notepointer+=8;
        if(Notepointer>=Endpointer)
                {
                Notepointer=0;
                Endpointer=512;
                }
        }
   if(counter2==4)
        {
if(Loop1==0) *Laenge1=1;
if(Loop2==0) *Laenge2=1;
if(Loop3==0) *Laenge3=1;
if(Loop4==0) *Laenge4=1;
        }
   counter2++;
   if(counter2>=5) counter2=0;	
/***********************************************************************/

 while(VBeamPos()!=200);
}

*DMACon=0x000f; 
Instruments=Start[1];
FreeMem(Instruments,Track->AllInstrLength);
FreeMem(Noten,Length);
FreeMem(Track,sizeof(struct FuchsTracker));
FreeMem(which,2200L);
FreeMem(ToWhat,2200L);
Fast=6;
}

PrintScoreTable()
{
int xi,SetY=83,Stunden,Minuten,Sekunden;
char s[20];

for(xi=0; xi<10; xi++)
	{
	FontPrint2(Place[xi].Name,27,SetY);

	s[0]=(Place[xi].Average/100)%10+0x30;
	s[1]=(Place[xi].Average/10)%10+0x30;
	s[2]=(Place[xi].Average)%10+0x30;
	s[3]='\0';
	FontPrint2(s,115,SetY);

	s[0]=(Place[xi].Level/10)%10+0x30;
	s[1]=(Place[xi].Level)%10+0x30;
	s[2]='\0';
	FontPrint2(s,195,SetY);

	Stunden=(Place[xi].Seconds/3600);
	Minuten=(Place[xi].Seconds-(Stunden*3600))/60;
	Sekunden=(Place[xi].Seconds-(Stunden*3600)-(Minuten*60));

	s[0]=(Stunden/10)%10+0x30;
	s[1]=(Stunden)%10+0x30;
	s[2]='\0';
	FontPrint2(s,259,SetY);
	s[0]=(Minuten/10)%10+0x30;
	s[1]=(Minuten)%10+0x30;
	s[2]='\0';
	FontPrint2(s,278,SetY);
	s[0]=(Sekunden/10)%10+0x30;
	s[1]=(Sekunden)%10+0x30;
	s[2]='\0';
	FontPrint2(s,297,SetY);

 	SetY+=12;
	}
}


FontPrint2(Stext,x,y)
char *Stext;
int x,y;
{
short Ende=0;
register int quik=0,Print_X,Print_Y;
Print_X=x;
Print_Y=y*5;

while(1)
{
switch(*(Stext+quik))         
   {
   case 'A':
   BltBitMap(&ShadowSourceMap,0,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'B':
   BltBitMap(&ShadowSourceMap,8,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'C':
   BltBitMap(&ShadowSourceMap,16,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'D':
   BltBitMap(&ShadowSourceMap,24,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'E':
   BltBitMap(&ShadowSourceMap,32,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'F':
   BltBitMap(&ShadowSourceMap,40,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'G':
   BltBitMap(&ShadowSourceMap,48,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'H':
   BltBitMap(&ShadowSourceMap,56,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'I':
   BltBitMap(&ShadowSourceMap,64,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'J':
   BltBitMap(&ShadowSourceMap,72,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'K':
   BltBitMap(&ShadowSourceMap,80,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'L':
   BltBitMap(&ShadowSourceMap,88,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'M':
   BltBitMap(&ShadowSourceMap,96,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'N':
   BltBitMap(&ShadowSourceMap,104,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'O':
   BltBitMap(&ShadowSourceMap,112,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'P':
   BltBitMap(&ShadowSourceMap,120,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'Q':
   BltBitMap(&ShadowSourceMap,128,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'R':
   BltBitMap(&ShadowSourceMap,136,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'S':
   BltBitMap(&ShadowSourceMap,144,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'T':
   BltBitMap(&ShadowSourceMap,152,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'U':
   BltBitMap(&ShadowSourceMap,160,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'V':
   BltBitMap(&ShadowSourceMap,168,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'W':
   BltBitMap(&ShadowSourceMap,176,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'X':
   BltBitMap(&ShadowSourceMap,184,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'Y':
   BltBitMap(&ShadowSourceMap,192,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case 'Z':
   BltBitMap(&ShadowSourceMap,200,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '1':
   BltBitMap(&ShadowSourceMap,208,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '2':
   BltBitMap(&ShadowSourceMap,216,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '3':
   BltBitMap(&ShadowSourceMap,224,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '4':
   BltBitMap(&ShadowSourceMap,232,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '5':
   BltBitMap(&ShadowSourceMap,240,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '6':
   BltBitMap(&ShadowSourceMap,248,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '7':
   BltBitMap(&ShadowSourceMap,256,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '8':
   BltBitMap(&ShadowSourceMap,264,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '9':
   BltBitMap(&ShadowSourceMap,272,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '0':
   BltBitMap(&ShadowSourceMap,280,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case '.':
   BltBitMap(&ShadowSourceMap,288,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=8;
   break;
   case ':':
   BltBitMap(&ShadowSourceMap,296,0,&BaukaMap,Print_X,Print_Y,8,45,0xc0,0xff,0);
   Print_X+=4;
   break;
   case '\0':
   Ende=1;
   break;
   default:
   Print_X+=8;
   break;
   }
quik++;
if(Ende==1 || quik>=9) break;
}

}   
